<%--
 * Component: billing
 *
 * Provides accounting information about spatial registration objects received for studies from designated devices.
 *
--%><%@page import="imagemed.lists.ListSaveForm"%>
<%@page import="imagemed.exception.IMException"%>
<%@page

	import="
		imagemed.filters.*,
		imagemed.imsession.*,imagemed.tables.*, imagemed.imtables.*, imagemed.http.IMRequest, imagemed.util.*,
		imagemed.jsputil.TabToolbox,
		imagemed.layout.*,
		imagemed.layout.datasource.*,
		imagemed.lists.ListDescriptor,
		imagemed.sqltables.TableUpdator,
		imagemed.types.flag.IMTypeur,
	
		java.io.IOException,
		java.sql.*,
		java.util.*
	"

%><%@page

	errorPage ="../main/exceptionHandler.jsp"

%><%!

static String thisPageMenuTab = "billing/rgselect.jsp";
static String thisPage = "/" + thisPageMenuTab;

%><%

IMSession is = new IMSession( request, response, out );

if ( !is.regOK() ) {
	return;
}

IMRequest imRequest = is.imRequest;

String context = imRequest.m_context;

boolean contextChanged = false;

if( !Table.isExporting(is) ) {
	is.setNonCacheable();
	if (context == null || context.length() == 0) {
		// adding default filters to the context - so it remains when sorts, or other filters are added
		imRequest.setProperty( "qf_DYRT", "\"" + LayoutPart.SPATIALBILLINGLAYOUT + "\"" );
		imRequest.setProperty( "qf_DYTN", "\"DynTempSpatialRegReport\"" );
		
		context = imRequest.backupContext();
		// we did not have a context, redirect the page now.
		response.sendRedirect(thisPage+"?cContext="+context);
		return;
	}
	else {
		// just save the context
		imRequest.passAsFile(context);
	}
}


String title = LocalizedMessage.getSimpleMessage( "SPATREG_SELECT_TITLE" );

IMBaseFieldManager fmReg = EntryLayoutFactory.getDefaultFieldManager( is, LayoutPart.SPATIALBILLINGLAYOUT );

IMBaseFieldManager fm = EntryLayoutFactory.getDefaultFieldManager( is, LayoutPart.DYNTEMPTABLELAYOUT );

//--- Init Table without Result ---
TableDescriptor tdesc = new TableDescriptor( thisPage, true, true, true, false );
TableProperties tprop = new TableProperties();

WorklistTableParams tparams = new WorklistTableParams( is, is.getProfileUser(), is.hasRight( IMTypeur.ADMIN_RIGHT ), is.isRegisteredViewer() );


tdesc.setFieldManager( fm );
tdesc.setTableParams( tparams );
tdesc.setTableProperties( tprop );
tdesc.setSortDepth( 3 );

Action acts[] = new Action[ 2 ];

acts[ 0 ] = new LinkAction( tdesc, "DYRI",
	"javascript:redirPage_b(\"rgreport.jsp?qf_DYRI=<searchfilter>$$DYRI$$</searchfilter>\")",
	"<script language=javascript>" +
	"getImage2node(false, \"qview.gif\", 0, 0, \"" +
	LocalizedMessage.getSimpleMessage( "SPATREG_VIEW" ) +
	"\");" +
	"</script>", null );

acts[ 1 ] = new LinkAction( tdesc, "DYRI", "javascript:redirPage_b(\"rgselect.jsp?cDYRI=$$DYRI$$&cOp=Delete\")",
		"<script language=\"JavaScript\">getImage(\'delete\', 18, 20, \' alt=\"" + LocalizedMessage.getSimpleMessage( "DELETE_SPATIAL_REPORT" ) + "\" title=\"" + LocalizedMessage.getSimpleMessage( "DELETE_SPATIAL_REPORT" ) + "\"\');</script>",
		LocalizedMessage.getSimpleMessage( "DELETE_SPATIAL_REPORT" ) );

Column col = new Column( new SimpleHeader( "Reports" ), new ActionCell( "DYRI", acts ), "DYRI" );

tdesc.addExtraColumn( "_FIRST", col );

List<TopCell> topCell = new ArrayList<TopCell>();

TitleTopCell tit = new TitleTopCell(tprop, "<nobr>" + LocalizedMessage.getSimpleMessage( "SPATREG_SELECT_EXISTING" ) + "</nobr>" );
tit.clearWidth();

topCell.add( tit );

topCell.add( new SeparatorTopCell(tprop, 4) );

topCell.add( new ListsTopCell( ListDescriptor.LIST_SPATREGFILTER, tdesc, is.getProfileUser(), true) ); 
topCell.add( new SeparatorTopCell(tprop, 4) );

topCell.add( new FieldsTopCell(tdesc, null, true) );
topCell.add( new FiltersTopCell(tdesc, null, false, new String[0], true) );
topCell.add( new SortsTopCell(tdesc, null, false, true) );

topCell.add( new PageTopCell(tprop, tparams) );
tdesc.setTopCells(topCell);

DBLayoutDataSource dblds = EntryLayoutFactory.getDefaultDBLDS( is, LayoutPart.DYNTEMPTABLELAYOUT );
DBLDSWrapperNatSqlResult result = new DBLDSWrapperNatSqlResult( tdesc, dblds );
result.setRequiredFields( new String[]{ "DYRI", "DYTN" } );

tdesc.setResult( result );
Table table = new Table( tdesc );


%><%--
 * 
 * HTML
 *
--%><HTML><HEAD>
 <TITLE><%= title %></TITLE>

 <SCRIPT Language="JavaScript">
		var pageContext="<%=context%>";
 </script>
 <script src="//code.jquery.com/jquery-1.10.2.js"></script>
 <script src="//code.jquery.com/ui/1.10.4/jquery-ui.js"></script>
 <link rel="stylesheet" href="//code.jquery.com/ui/1.10.4/themes/smoothness/jquery-ui.css">
	
<%

TabToolbox.writeIMpopup( is.out );
table.printScript( tparams, is );
JSHelper.printJsInclude( out, "/cases/js/FilterScripts.js" );

%>
	<SCRIPT language="JavaScript">
		function doSubmit( frm, mod, mes ) {
			if( !document.getElementById('0LEDdatNEWERcb').checked &&
				!document.getElementById('0LEDdatFURTHERcb').checked &&
				!document.getElementById('0LEDdatOLDERcb').checked &&
				!document.getElementById('0LEDdatCLOSERcb').checked &&
				!document.getElementById('0LEDdatAFTERcb').checked &&
				!document.getElementById('0LEDdatBEFOREcb').checked ) {
				alert( mes );		
			}
			else {
				while ( frm.cOp.value != mod ) {
					frm.cOp.value = mod;
				}
				frm.submit();
			}
		}

		function openPrintFriendly( url ) {
			window.open( url, "imw_printfriendly", "resizable,scrollbar,menubar=yes,toolbar=yes" );
		}
	</script>
</head>
<BODY>
<% 

TabToolbox.makeTabs( is,is.tabbean, thisPageMenuTab, "White" );

Helper.DEBUG( "querystring:" + is.request.getQueryString() );

String parOp = imRequest.getVal( "cOp" );
String parBack = imRequest.getVal( "cBack" );
String parReportID = imRequest.getVal( "cDYRI" );

if ( "Delete".equals( parOp ) ) {
%>
	<FORM name="operForm" method="POST" action="<%=thisPage%>">
		<CENTER>
  	<H2><P>&nbsp;
		<P><%=LocalizedMessage.getSimpleMessage( "SPATREG_DELETE_MSG" )%>
		<P>
		<input type=hidden name="cDYRI" value="<%=parReportID%>">
		<input type=hidden name="cBack" value="<%=parBack%>">
		<%=JSHelper.getJsInputLocalizedButton( is, "BUTTON_DELETE", "cOp", "DeleteSure")%>
		&nbsp; &nbsp; &nbsp; &nbsp;
		<a href="<%=parBack%>"><%=JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false )%></a>
		</H2>
		</CENTER>
	</FORM>
</body>
</html>
<%
	return;
}
else if ( "DeleteSure".equals( parOp ) ) {
	if( parReportID == null ) {
		Helper.ERRORLOG( "parReportID is null in Delete" );
	}
	else {
		TempTableSession.deleteDynResult( is, LayoutPart.SPATIALBILLINGLAYOUT, parReportID );
	}
	if ( parBack != null && parBack.length() > 0 ) {
%><script language="JavaScript">
		document.location="<%=parBack%>";
</script><%
//		response.sendRedirect( parBack );
		return;
	}
}

else if ( "new".equals( parOp ) ) {
	out.println( "<CENTER>" );
	MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "SPATREG_MESSAGEBOX_TITLE" ), "60%" );
	mb.setMessage( LocalizedMessage.getSimpleMessage( "SPATREG_MESSAGEBOX_TEXT" ) );
	mb.print( is.out );
	out.println( "</BODY></HTML>" );
	out.flush();
	
	String filter = fmReg.processFilter( "0LED", imRequest.getParTable() );

	IMFilterStringDate dateFilter = new IMFilterStringDate( filter, true );

	StringBuilder desc = new StringBuilder( 256 );
	Long[] range = dateFilter.getAbsoluteTZConvertedDateLongRange();
	desc.append( LocalizedMessage.getSimpleMessage( "SPATREG_DESC" ) );
	Calendar calFrom = null;
	Calendar calTo = null;
	if ( range[ 0 ] != null ) {
		calFrom = Calendar.getInstance();
		calFrom.setTimeInMillis( range[ 0 ] );
	}
	if ( range[ 1 ] != null ) {
		calTo = Calendar.getInstance();
		calTo.setTimeInMillis( range[ 1 ] );
	}
	if ( calFrom == null && calTo == null ) {
		// will never come here because of javascript dosubmit
		throw new IMException( "No date range was selected" );
	}
	else if ( calFrom == null ) {
		// only calTo
		desc.append( String.format( " " + LocalizedMessage.getSimpleMessage( "termTO" ) + " %1$tF %1$tR", calTo ) );
	}
	else if ( calTo == null ) {
		// only calFrom
		desc.append( String.format( " " + LocalizedMessage.getSimpleMessage( "termFROM" ) + " %1$tF %1$tR", calFrom ) );
	}
	else {
		String fromTm = String.format( "%1$tR", calFrom );
		String toTm = String.format( "%1$tR", calTo );
		
		if ( fromTm.equals( toTm ) ) {
			desc.append( String.format( " " + LocalizedMessage.getSimpleMessage( "termFROM" ) + " %1$tF " + LocalizedMessage.getSimpleMessage( "termTO" ) + " %2$tF", calFrom, calTo ) );
		}
		else {
			desc.append( String.format( " " + LocalizedMessage.getSimpleMessage( "termFROM" ) + " %1$tF %1$tR " + LocalizedMessage.getSimpleMessage( "termTO" ) + " %2$tF %2$tR", calFrom, calTo ) );
		}
	}
	
	Helper.DEBUG( "spatreg Desc: " + desc.toString() );
	Helper.DEBUG( "spatreg filter: " + filter );
	
	String dynResId =  TempTableSession.newDynResult( is, LayoutPart.SPATIALBILLINGLAYOUT, desc.toString() );
	SpatialLogResult.checkAndCreateTable( dynResId, filter );
	
	Helper.DEBUG( "parback added from new op:" + parBack );

%><script language="JavaScript">
	document.location="<%="rgreport.jsp?qf_DYRI=<searchfilter>" + dynResId + "</searchfilter>&cBack=" + Helper.URLEncodeUTF8( parBack )%>";
</script><%
	return;
	
}


%>
 <TABLE border=1 cellpadding=0 cellspacing=0 width="100%">
  <TR>
   <TD class=BgShadow width="50%">
    <BR/>
    <FONT size=4>&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "SPATREG_CREATENEW" )%> </FONT>
    <BR/><BR/>
   </TD>
  </TR>
  <TR>
   <TD>
    <FORM method=post name="saveForm" id="saveForm" action="/billing/rgselect.jsp">
    <TABLE border=1 cellpadding=0 cellspacing=0 width="100%">
	 <TR class=HeaderRow>
		<%= Helper.headerCell3D( "  " + LocalizedMessage.getSimpleMessage( "GENERIC_FIELDS" ) ) %>
		<%= Helper.headerCell3D( "  " + LocalizedMessage.getSimpleMessage( "GENERIC_SETTINGS" ), "left", 3 )%>
	 </TR>
	 <%-- Filter on logs date only --%>
<%
Properties filterPrp = new Properties();
filterPrp.setProperty( "RangeOnly", "true" );
filterPrp.setProperty( "UIName", "Date range" );

%>
	 <%= new IMFilterDate( IMFilter.FILTER_MODE_NORMAL ).input( "0LED", "Dt", "(0 CM-1 CM)()()", filterPrp ) %> 
 	</TABLE>
    <INPUT type="hidden" name="cOp" />
    <INPUT type="hidden" name="cBack" value="<%=TableParams.getBackParamsForForms( is )%>" />
    </FORM>
   </TD>
  </TR>
  <TR>
   <TD class=BgShadow nowrap align=right>
    <BR/>
    <a href="javascript:doSubmit( self.document.saveForm, 'new', '<%= LocalizedMessage.getSimpleMessage( "SPATREG_EMPTY_CALENDAR" )%>' )"><%=JSHelper.getJsLocalizedButton( "BUTTON_APPLY", "BUTTON_APPLY", false ) %></a>
    <BR/>
   </TD>
  </TR>
  <TR>
   <TD class=FieldBlock></TD>
  </TR>
<%

if ( result.countAll() > 0 ) {
%>
  <TR>
   <TD>
<%
	table.printTableTop( is );
	table.print( is );
%>
<%=ListSaveForm.getListSaveForm( ListDescriptor.LIST_SPATREGFILTER, is, tdesc)%>   </TD>
  </TR>
<%
}
%>
 </TABLE>
</BODY>
</HTML>
